import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata } from '../slang-utils/metadata.js';
import { joinExisting } from '../slang-utils/join-existing.js';
export class AddressType {
    constructor(ast, offset) {
        var _a;
        this.kind = NonterminalKind.AddressType;
        const metadata = getNodeMetadata(ast, offset);
        this.payableKeyword = (_a = ast.payableKeyword) === null || _a === void 0 ? void 0 : _a.unparse();
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print() {
        return joinExisting(' ', ['address', this.payableKeyword]);
    }
}
//# sourceMappingURL=AddressType.js.map