import { doc } from 'prettier';
import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { CatchClause } from './CatchClause.js';
const { join } = doc.builders;
export class CatchClauses {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.CatchClauses;
        let metadata = getNodeMetadata(ast, offset, true);
        const { offsets } = metadata;
        this.items = ast.items.map((item, index) => new CatchClause(item, offsets[index], options));
        metadata = updateMetadata(metadata, [this.items]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return join(' ', path.map(print, 'items'));
    }
}
//# sourceMappingURL=CatchClauses.js.map