import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { EventParameters } from './EventParameters.js';
export class EventParametersDeclaration {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.EventParametersDeclaration;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.parameters = new EventParameters(ast.parameters, offsets[0], options);
        metadata = updateMetadata(metadata, [this.parameters]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return ['(', path.call(print, 'parameters'), ')'];
    }
}
//# sourceMappingURL=EventParametersDeclaration.js.map