import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { ExperimentalFeature } from './ExperimentalFeature.js';
export class ExperimentalPragma {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.ExperimentalPragma;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.feature = new ExperimentalFeature(ast.feature, offsets[0], options);
        metadata = updateMetadata(metadata, [this.feature]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return ['experimental ', path.call(print, 'feature')];
    }
}
//# sourceMappingURL=ExperimentalPragma.js.map