import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata } from '../slang-utils/metadata.js';
import { Identifier } from './Identifier.js';
export class FunctionName {
    constructor(ast, offset) {
        this.kind = NonterminalKind.FunctionName;
        const metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.variant = new Identifier(ast.variant, offsets[0]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return path.call(print, 'variant');
    }
}
//# sourceMappingURL=FunctionName.js.map