import { doc } from 'prettier';
import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { HexStringLiteral } from './HexStringLiteral.js';
const { join, hardline } = doc.builders;
export class HexStringLiterals {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.HexStringLiterals;
        let metadata = getNodeMetadata(ast, offset, true);
        const { offsets } = metadata;
        this.items = ast.items.map((item, index) => new HexStringLiteral(item, offsets[index], options));
        metadata = updateMetadata(metadata, [this.items]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return join(hardline, path.map(print, 'items'));
    }
}
//# sourceMappingURL=HexStringLiterals.js.map