import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata } from '../slang-utils/metadata.js';
import { Identifier } from './Identifier.js';
export class IdentifierPath {
    constructor(ast, offset) {
        this.kind = NonterminalKind.IdentifierPath;
        const metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.items = ast.items.map((item, index) => new Identifier(item, offsets[index]));
        this.separators = ast.separators.map((separator) => separator.unparse());
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return path
            .map(print, 'items')
            .map((item, index) => index === 0 ? item : [this.separators[index - 1], item]);
    }
}
//# sourceMappingURL=IdentifierPath.js.map