import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata } from '../slang-utils/metadata.js';
import { Identifier } from './Identifier.js';
export class ImportAlias {
    constructor(ast, offset) {
        this.kind = NonterminalKind.ImportAlias;
        const metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.identifier = new Identifier(ast.identifier, offsets[0]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [' as ', path.call(print, 'identifier')];
    }
}
//# sourceMappingURL=ImportAlias.js.map