import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { Identifier } from './Identifier.js';
import { ImportAlias } from './ImportAlias.js';
export class ImportDeconstructionSymbol {
    constructor(ast, offset) {
        this.kind = NonterminalKind.ImportDeconstructionSymbol;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.name = new Identifier(ast.name, offsets[0]);
        if (ast.alias) {
            this.alias = new ImportAlias(ast.alias, offsets[1]);
        }
        metadata = updateMetadata(metadata, [this.alias]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [path.call(print, 'name'), path.call(print, 'alias')];
    }
}
//# sourceMappingURL=ImportDeconstructionSymbol.js.map