import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { ImportClause } from './ImportClause.js';
export class ImportDirective {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.ImportDirective;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.clause = new ImportClause(ast.clause, offsets[0], options);
        metadata = updateMetadata(metadata, [this.clause]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return ['import ', path.call(print, 'clause'), ';'];
    }
}
//# sourceMappingURL=ImportDirective.js.map