import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { MappingKey } from './MappingKey.js';
import { MappingValue } from './MappingValue.js';
export class MappingType {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.MappingType;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.keyType = new MappingKey(ast.keyType, offsets[0]);
        this.valueType = new MappingValue(ast.valueType, offsets[1], options);
        metadata = updateMetadata(metadata, [this.keyType, this.valueType]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [
            'mapping(',
            path.call(print, 'keyType'),
            ' => ',
            path.call(print, 'valueType'),
            ')'
        ];
    }
}
//# sourceMappingURL=MappingType.js.map