import { TerminalKind } from '@nomicfoundation/slang/cst';
import { doc } from 'prettier';
import { isIndentableBlockComment } from '../slang-utils/is-indentable-block-comment.js';
import { printIndentableBlockComment } from '../slang-printers/print-indentable-block-comment.js';
const { join, literalline } = doc.builders;
export class MultiLineComment {
    constructor(ast, offset) {
        this.kind = TerminalKind.MultiLineComment;
        this.value = ast.unparse();
        this.loc = {
            start: offset,
            end: offset + ast.textLength.utf16
        };
    }
    print() {
        if (isIndentableBlockComment(this)) {
            return printIndentableBlockComment(this);
        }
        return join(literalline, this.value.split('\n'));
    }
}
//# sourceMappingURL=MultiLineComment.js.map