import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { NamedArgumentGroup } from './NamedArgumentGroup.js';
export class NamedArgumentsDeclaration {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.NamedArgumentsDeclaration;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        if (ast.arguments) {
            this.arguments = new NamedArgumentGroup(ast.arguments, offsets[0], options);
        }
        metadata = updateMetadata(metadata, [this.arguments]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return ['(', path.call(print, 'arguments'), ')'];
    }
}
//# sourceMappingURL=NamedArgumentsDeclaration.js.map