import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { ImportAlias } from './ImportAlias.js';
import { StringLiteral } from './StringLiteral.js';
export class NamedImport {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.NamedImport;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.alias = new ImportAlias(ast.alias, offsets[0]);
        this.path = new StringLiteral(ast.path, offsets[1], options);
        metadata = updateMetadata(metadata, [this.alias, this.path]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return ['*', path.call(print, 'alias'), ' from ', path.call(print, 'path')];
    }
}
//# sourceMappingURL=NamedImport.js.map