import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { printSeparatedList } from '../slang-printers/print-separated-list.js';
import { IdentifierPath } from './IdentifierPath.js';
export class OverridePaths {
    constructor(ast, offset) {
        this.kind = NonterminalKind.OverridePaths;
        let metadata = getNodeMetadata(ast, offset, true);
        const { offsets } = metadata;
        this.items = ast.items.map((item, index) => new IdentifierPath(item, offsets[index]));
        this.separators = ast.separators.map((separator) => separator.unparse());
        metadata = updateMetadata(metadata, [this.items]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return printSeparatedList(path.map(print, 'items'));
    }
}
//# sourceMappingURL=OverridePaths.js.map