import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { StringLiteral } from './StringLiteral.js';
import { ImportAlias } from './ImportAlias.js';
export class PathImport {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.PathImport;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.path = new StringLiteral(ast.path, offsets[0], options);
        if (ast.alias) {
            this.alias = new ImportAlias(ast.alias, offsets[1]);
        }
        metadata = updateMetadata(metadata, [this.path, this.alias]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [path.call(print, 'path'), path.call(print, 'alias')];
    }
}
//# sourceMappingURL=PathImport.js.map