import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { Expression } from './Expression.js';
export class PostfixExpression {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.PostfixExpression;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.operand = new Expression(ast.operand, offsets[0], options);
        this.operator = ast.operator.unparse();
        metadata = updateMetadata(metadata, [this.operand]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [path.call(print, 'operand'), this.operator];
    }
}
//# sourceMappingURL=PostfixExpression.js.map