import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { Expression } from './Expression.js';
export class PrefixExpression {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.PrefixExpression;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.operator = ast.operator.unparse();
        this.operand = new Expression(ast.operand, offsets[0], options);
        metadata = updateMetadata(metadata, [this.operand]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
        if (this.operator === 'delete') {
            this.operator = `${this.operator} `;
        }
    }
    print(path, print) {
        return [this.operator, path.call(print, 'operand')];
    }
}
//# sourceMappingURL=PrefixExpression.js.map