import { NonterminalKind, TerminalNode } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { OverrideSpecifier } from './OverrideSpecifier.js';
export class StateVariableAttribute {
    constructor(ast, offset) {
        this.kind = NonterminalKind.StateVariableAttribute;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.variant =
            ast.variant instanceof TerminalNode
                ? ast.variant.unparse()
                : new OverrideSpecifier(ast.variant, offsets[0]);
        metadata = updateMetadata(metadata, typeof this.variant === 'string' ? [] : [this.variant]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return typeof this.variant === 'string'
            ? this.variant
            : path.call(print, 'variant');
    }
}
//# sourceMappingURL=StateVariableAttribute.js.map