import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { doc } from 'prettier';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { sortFunctionAttributes } from '../slang-utils/sort-function-attributes.js';
import { StateVariableAttribute } from './StateVariableAttribute.js';
const { line } = doc.builders;
export class StateVariableAttributes {
    constructor(ast, offset) {
        this.kind = NonterminalKind.StateVariableAttributes;
        let metadata = getNodeMetadata(ast, offset, true);
        const { offsets } = metadata;
        this.items = ast.items.map((item, index) => new StateVariableAttribute(item, offsets[index]));
        metadata = updateMetadata(metadata, [this.items]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
        this.items = this.items.sort(sortFunctionAttributes);
    }
    print(path, print) {
        return this.items.length
            ? path.map(print, 'items').map((item) => [line, item])
            : '';
    }
}
//# sourceMappingURL=StateVariableAttributes.js.map