import { doc } from 'prettier';
import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { Expression } from './Expression.js';
const { group, indent, line } = doc.builders;
export class StateVariableDefinitionValue {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.StateVariableDefinitionValue;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.value = new Expression(ast.value, offsets[0], options);
        metadata = updateMetadata(metadata, [this.value]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return typeof this.value.variant !== 'string' &&
            this.value.variant.kind === NonterminalKind.ArrayExpression
            ? [' = ', path.call(print, 'value')]
            : group([' =', indent([line, path.call(print, 'value')])]);
    }
}
//# sourceMappingURL=StateVariableDefinitionValue.js.map