import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { printString } from '../slang-printers/print-string.js';
import { getNodeMetadata } from '../slang-utils/metadata.js';
export class StringLiteral {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.StringLiteral;
        const metadata = getNodeMetadata(ast, offset);
        this.variant = ast.variant.unparse();
        this.comments = metadata.comments;
        this.loc = metadata.loc;
        this.variant = printString(this.variant.slice(1, -1), options);
    }
    print() {
        return this.variant;
    }
}
//# sourceMappingURL=StringLiteral.js.map