import { doc } from 'prettier';
import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { StringLiteral } from './StringLiteral.js';
const { join, hardline } = doc.builders;
export class StringLiterals {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.StringLiterals;
        let metadata = getNodeMetadata(ast, offset, true);
        const { offsets } = metadata;
        this.items = ast.items.map((item, index) => new StringLiteral(item, offsets[index], options));
        metadata = updateMetadata(metadata, [this.items]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return join(hardline, path.map(print, 'items'));
    }
}
//# sourceMappingURL=StringLiterals.js.map