import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { Identifier } from './Identifier.js';
import { StructMembers } from './StructMembers.js';
export class StructDefinition {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.StructDefinition;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.name = new Identifier(ast.name, offsets[0]);
        this.members = new StructMembers(ast.members, offsets[1], options);
        metadata = updateMetadata(metadata, [this.members]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [
            'struct ',
            path.call(print, 'name'),
            ' {',
            path.call(print, 'members'),
            '}'
        ];
    }
}
//# sourceMappingURL=StructDefinition.js.map