import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { TypeName } from './TypeName.js';
import { Identifier } from './Identifier.js';
export class StructMember {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.StructMember;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.typeName = new TypeName(ast.typeName, offsets[0], options);
        this.name = new Identifier(ast.name, offsets[1]);
        metadata = updateMetadata(metadata, [this.typeName]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [path.call(print, 'typeName'), ' ', path.call(print, 'name'), ';'];
    }
}
//# sourceMappingURL=StructMember.js.map