import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { TupleValues } from './TupleValues.js';
export class TupleExpression {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.TupleExpression;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.items = new TupleValues(ast.items, offsets[0], options);
        metadata = updateMetadata(metadata, [this.items]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return ['(', path.call(print, 'items'), ')'];
    }
}
//# sourceMappingURL=TupleExpression.js.map