import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { Expression } from './Expression.js';
export class TupleValue {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.TupleValue;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        if (ast.expression) {
            this.expression = new Expression(ast.expression, offsets[0], options);
        }
        metadata = updateMetadata(metadata, [this.expression]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return path.call(print, 'expression');
    }
}
//# sourceMappingURL=TupleValue.js.map