import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { Block } from './Block.js';
export class UncheckedBlock {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.UncheckedBlock;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.block = new Block(ast.block, offsets[0], options);
        metadata = updateMetadata(metadata, [this.block]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return ['unchecked ', path.call(print, 'block')];
    }
}
//# sourceMappingURL=UncheckedBlock.js.map