import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { printString } from '../slang-printers/print-string.js';
import { getNodeMetadata } from '../slang-utils/metadata.js';
export class UnicodeStringLiteral {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.UnicodeStringLiteral;
        const metadata = getNodeMetadata(ast, offset);
        this.variant = ast.variant.unparse();
        this.comments = metadata.comments;
        this.loc = metadata.loc;
        this.variant = `unicode${printString(this.variant.slice(8, -1), options)}`;
    }
    print() {
        return this.variant;
    }
}
//# sourceMappingURL=UnicodeStringLiteral.js.map