import { doc } from 'prettier';
import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { UnicodeStringLiteral } from './UnicodeStringLiteral.js';
const { join, hardline } = doc.builders;
export class UnicodeStringLiterals {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.UnicodeStringLiterals;
        let metadata = getNodeMetadata(ast, offset, true);
        const { offsets } = metadata;
        this.items = ast.items.map((item, index) => new UnicodeStringLiteral(item, offsets[index], options));
        metadata = updateMetadata(metadata, [this.items]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return join(hardline, path.map(print, 'items'));
    }
}
//# sourceMappingURL=UnicodeStringLiterals.js.map