import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { Identifier } from './Identifier.js';
import { ElementaryType } from './ElementaryType.js';
export class UserDefinedValueTypeDefinition {
    constructor(ast, offset) {
        this.kind = NonterminalKind.UserDefinedValueTypeDefinition;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.name = new Identifier(ast.name, offsets[0]);
        this.valueType = new ElementaryType(ast.valueType, offsets[1]);
        metadata = updateMetadata(metadata, [this.valueType]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [
            'type ',
            path.call(print, 'name'),
            ' is ',
            path.call(print, 'valueType'),
            ';'
        ];
    }
}
//# sourceMappingURL=UserDefinedValueTypeDefinition.js.map