import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { UsingOperator } from './UsingOperator.js';
export class UsingAlias {
    constructor(ast, offset) {
        this.kind = NonterminalKind.UsingAlias;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.operator = new UsingOperator(ast.operator, offsets[0]);
        metadata = updateMetadata(metadata, [this.operator]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [' as ', path.call(print, 'operator')];
    }
}
//# sourceMappingURL=UsingAlias.js.map