import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { IdentifierPath } from './IdentifierPath.js';
import { UsingAlias } from './UsingAlias.js';
export class UsingDeconstructionSymbol {
    constructor(ast, offset) {
        this.kind = NonterminalKind.UsingDeconstructionSymbol;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.name = new IdentifierPath(ast.name, offsets[0]);
        if (ast.alias) {
            this.alias = new UsingAlias(ast.alias, offsets[1]);
        }
        metadata = updateMetadata(metadata, [this.name, this.alias]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [path.call(print, 'name'), path.call(print, 'alias')];
    }
}
//# sourceMappingURL=UsingDeconstructionSymbol.js.map