import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { Expression } from './Expression.js';
export class VariableDeclarationValue {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.VariableDeclarationValue;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.expression = new Expression(ast.expression, offsets[0], options);
        metadata = updateMetadata(metadata, [this.expression]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [' = ', path.call(print, 'expression')];
    }
}
//# sourceMappingURL=VariableDeclarationValue.js.map