import { doc } from 'prettier';
import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { VersionExpression } from './VersionExpression.js';
const { join } = doc.builders;
export class VersionExpressionSet {
    constructor(ast, offset) {
        this.kind = NonterminalKind.VersionExpressionSet;
        let metadata = getNodeMetadata(ast, offset, true);
        const { offsets } = metadata;
        this.items = ast.items.map((item, index) => new VersionExpression(item, offsets[index]));
        metadata = updateMetadata(metadata, [this.items]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return join(' ', path.map(print, 'items'));
    }
}
//# sourceMappingURL=VersionExpressionSet.js.map