import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { VersionLiteral } from './VersionLiteral.js';
export class VersionRange {
    constructor(ast, offset) {
        this.kind = NonterminalKind.VersionRange;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.start = new VersionLiteral(ast.start, offsets[0]);
        this.end = new VersionLiteral(ast.end, offsets[1]);
        metadata = updateMetadata(metadata, [this.start, this.end]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [path.call(print, 'start'), ' - ', path.call(print, 'end')];
    }
}
//# sourceMappingURL=VersionRange.js.map