import { doc } from 'prettier';
import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata } from '../slang-utils/metadata.js';
import { YulIdentifier } from './YulIdentifier.js';
const { dedent, line } = doc.builders;
export class YulLabel {
    constructor(ast, offset) {
        this.kind = NonterminalKind.YulLabel;
        const metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.label = new YulIdentifier(ast.label, offsets[0]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [dedent(line), path.call(print, 'label'), ':'];
    }
}
//# sourceMappingURL=YulLabel.js.map