import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { YulParameters } from './YulParameters.js';
export class YulParametersDeclaration {
    constructor(ast, offset) {
        this.kind = NonterminalKind.YulParametersDeclaration;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.parameters = new YulParameters(ast.parameters, offsets[0]);
        metadata = updateMetadata(metadata, [this.parameters]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return ['(', path.call(print, 'parameters'), ')'];
    }
}
//# sourceMappingURL=YulParametersDeclaration.js.map