import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata } from '../slang-utils/metadata.js';
import { YulIdentifier } from './YulIdentifier.js';
export class YulPathComponent {
    constructor(ast, offset) {
        this.kind = NonterminalKind.YulPathComponent;
        const metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.variant = new YulIdentifier(ast.variant, offsets[0]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return path.call(print, 'variant');
    }
}
//# sourceMappingURL=YulPathComponent.js.map