import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { YulPath } from './YulPath.js';
export class YulPaths {
    constructor(ast, offset) {
        this.kind = NonterminalKind.YulPaths;
        let metadata = getNodeMetadata(ast, offset, true);
        const { offsets } = metadata;
        this.items = ast.items.map((item, index) => new YulPath(item, offsets[index]));
        this.separators = ast.separators.map((separator) => separator.unparse());
        metadata = updateMetadata(metadata, [this.items]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return path
            .map(print, 'items')
            .map((item, index) => index === 0 ? item : [this.separators[index - 1], item]);
    }
}
//# sourceMappingURL=YulPaths.js.map