import { NonterminalKind } from '@nomicfoundation/slang/cst';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { YulAssignmentOperator } from './YulAssignmentOperator.js';
import { YulExpression } from './YulExpression.js';
export class YulVariableDeclarationValue {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.YulVariableDeclarationValue;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.assignment = new YulAssignmentOperator(ast.assignment, offsets[0]);
        this.expression = new YulExpression(ast.expression, offsets[1], options);
        metadata = updateMetadata(metadata, [this.assignment, this.expression]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [
            path.call(print, 'assignment'),
            ' ',
            path.call(print, 'expression')
        ];
    }
}
//# sourceMappingURL=YulVariableDeclarationValue.js.map