import { doc } from 'prettier';
import { joinExisting } from '../slang-utils/join-existing.js';
const { dedent, group, indent, line } = doc.builders;
export function printFunction(functionName, node, path, print) {
    return [
        group([
            functionName,
            path.call(print, 'parameters'),
            indent(group([
                joinExisting(line, [
                    path.call(print, 'attributes'),
                    path.call(print, 'returns')
                ]),
                node.body &&
                    node.body.variant !== ';'
                    ? dedent(line)
                    : ''
            ]))
        ]),
        path.call(print, 'body')
    ];
}
//# sourceMappingURL=print-function.js.map