export function isIndentableBlockComment(comment) {
    // If the comment has multiple lines and every line starts with a star
    // we can fix the indentation of each line. The stars in the `/*` and
    // `*/` delimiters are not included in the comment value, so add them
    // back first.
    const lines = comment.value.slice(1, -1).split('\n');
    return lines.length > 1 && lines.every((line) => line.trimStart()[0] === '*');
}
//# sourceMappingURL=is-indentable-block-comment.js.map